SystemOrganization addCategory: #'Announcements-Tests-Core'!

Announcement subclass: #AnnouncementMockA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Tests-Core'!

!AnnouncementMockA commentStamp: 'Tbn 11/12/2010 10:54' prior: 0!
This is a simple test mock.!

Announcement subclass: #AnnouncementMockB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Tests-Core'!

!AnnouncementMockB commentStamp: 'Tbn 11/12/2010 10:54' prior: 0!
This is a simple test mock!

AnnouncementMockB subclass: #AnnouncementMockC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Tests-Core'!

!AnnouncementMockC commentStamp: 'Tbn 11/12/2010 10:54' prior: 0!
This is a simple test mock!

TestCase subclass: #AnnouncementSetTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Tests-Core'!

!AnnouncementSetTest methodsFor: 'testing' stamp: 'Tbn 11/12/2010 11:07'!
testIncludeOnlyOnce
	|set|
	set := AnnouncementMockA, AnnouncementMockB, AnnouncementMockA.
	self assert: set size = 2! !

!AnnouncementSetTest methodsFor: 'testing' stamp: 'Sd 11/26/2010 17:31'!
testInstanceCreation
	|set|
	set := AnnouncementMockA, AnnouncementMockB.
	self assert: set size = 2 ! !

TestCase subclass: #AnnouncerTest
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Tests-Core'!

!AnnouncerTest commentStamp: 'Tbn 11/12/2010 10:55' prior: 0!
An AnnouncerTest is a test class used to test Announcer.

Instance Variables
	announcer:		<Announcer>  the announcer to test

announcer
	- the announcer that is tested
!

!AnnouncerTest class methodsFor: 'testing' stamp: 'lr 2/26/2011 11:35'!
shouldInheritSelectors
	^ true! !

!AnnouncerTest methodsFor: 'private' stamp: 'lr 2/26/2011 11:34'!
newAnnouncer
	^ Announcer new! !

!AnnouncerTest methodsFor: 'running' stamp: 'lr 2/26/2011 11:34'!
setUp
	super setUp.
	announcer := self newAnnouncer! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 3/2/2009 10:11'!
testAnnounceClass
	self assert: (announcer announce: AnnouncementMockA) 
		class = AnnouncementMockA! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 3/2/2009 10:10'!
testAnnounceInstance
	| instance |
	instance := AnnouncementMockA new.
	self assert: (announcer announce: instance) = instance! !

!AnnouncerTest methodsFor: 'testing' stamp: 'IgorStasenko 1/2/2012 15:54'!
testAnnouncingReentrant
	" Test that it is safe to announce when handling announcement,
	so announcer are reentrant "

	" self run: #testAnnouncingReentrant "

	| bool ok |

	ok := bool := false.
	announcer on: Announcement do: [
		bool ifFalse: [
			bool := true.
		announcer announce:  Announcement new. ]
		ifTrue: [ ok := true ] 
	].

	self should: [ announcer announce: Announcement new. ] notTakeMoreThan: 1 second.
	self assert: ok

! !

!AnnouncerTest methodsFor: 'testing' stamp: 'IgorStasenko 3/12/2011 21:47'!
testNoArgBlock
	"we are supposed to accept zero-argument blocks as actions "
	| announcement counter |
	counter := nil.

	self shouldnt: [	
		announcer
			subscribe: AnnouncementMockA 
			do: [ counter:= 1 ] ] raise: Exception.

	self shouldnt: [announcer announce: AnnouncementMockA new] raise: Exception.
	self assert:  counter =1! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 3/2/2009 10:08'!
testSubscribeBlock
	| announcement instance |
	announcer
		subscribe: AnnouncementMockA
		do: [ :ann | announcement := ann ].
		
	announcement := nil.
	instance := announcer announce: AnnouncementMockA.
	self assert: announcement = instance.
	
	announcement := nil.
	instance := announcer announce: AnnouncementMockB.
	self assert: announcement isNil! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 3/2/2009 10:07'!
testSubscribeSend
	| announcement instance |
	announcer
		subscribe: AnnouncementMockA
		send: #value:
		to: [ :ann | announcement := ann ].
		
	announcement := nil.
	instance := announcer announce: AnnouncementMockA.
	self assert: announcement = instance.
	
	announcement := nil.
	instance := announcer announce: AnnouncementMockB new.
	self assert: announcement isNil! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 3/2/2009 10:07'!
testSubscribeSet
	| announcement instance |
	announcer
		subscribe: AnnouncementMockA , AnnouncementMockC
		do: [ :ann | announcement := ann ].
		
	announcement := nil.
	instance := announcer announce: AnnouncementMockA.
	self assert: announcement = instance.
	
	announcement := nil.
	instance := announcer announce: AnnouncementMockB.
	self assert: announcement isNil.
	
	announcement := nil.
	instance := announcer announce: AnnouncementMockC.
	self assert: announcement = instance! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 3/2/2009 10:06'!
testSubscribeSubclass
	| announcement instance |
	announcer
		subscribe: AnnouncementMockB
		do: [ :ann | announcement := ann ].
		
	announcement := nil.
	instance := announcer announce: AnnouncementMockA.
	self assert: announcement isNil.

	announcement := nil.
	instance := announcer announce: AnnouncementMockB.
	self assert: announcement = instance.
	
	announcement := nil.
	instance := announcer announce: AnnouncementMockC.
	self assert: announcement = instance.! !

!AnnouncerTest methodsFor: 'testing' stamp: 'IgorStasenko 3/12/2011 21:46'!
testTwoArgBlock
	"we are supposed to accept two-argument blocks as actions "
	| announcement flag |
	
	
	self shouldnt: [
		announcer
			subscribe: AnnouncementMockA 
			do: [:ann :announcer2 | flag := announcer2 == announcer ]
		] raise: Exception.

	self shouldnt: [announcer announce: AnnouncementMockA new] raise: Exception.
	self assert:  flag! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 9/25/2006 09:10'!
testUnsubscribeBlock
	| announcement |
	announcer
		subscribe: AnnouncementMockA
		do: [ :ann | announcement := ann ].
	announcer
		unsubscribe: self.

	announcement := nil.
	announcer announce: AnnouncementMockA new.
	self assert: announcement isNil! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 9/25/2006 09:13'!
testUnsubscribeSend
	| announcement receiver |
	announcer
		subscribe: AnnouncementMockA
		send: #value:
		to: (receiver := [ :ann | announcement := ann ]).
	announcer
		unsubscribe: receiver.

	announcement := nil.
	announcer announce: AnnouncementMockA new.
	self assert: announcement isNil! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 9/25/2006 09:13'!
testUnsubscribeSet
	| announcement |
	announcer
		subscribe: AnnouncementMockA , AnnouncementMockB
		do: [ :ann | announcement := ann ].
	announcer
		unsubscribe: self.

	announcement := nil.
	announcer announce: AnnouncementMockA new.
	self assert: announcement isNil.
	
	announcement := nil.
	announcer announce: AnnouncementMockB new.
	self assert: announcement isNil.! !

AnnouncerTest subclass: #WeakAnnouncerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Tests-Core'!

!WeakAnnouncerTest methodsFor: 'benchmarks' stamp: 'IgorStasenko 3/12/2011 21:40'!
benchManyWeakGuys

	| object ann time |
	
	object := Object new.
	ann := Announcer new.
	
	50000 timesRepeat: [ (ann weak on: Announcement send: #value to: object) ].
	
	self assert: (ann numberOfSubscriptions =  50000).
	
	Smalltalk garbageCollect.
	
	time := [object := nil.
		Smalltalk garbageCollect. 
		 ]timeToRun.
	
	self assert: (ann numberOfSubscriptions = 0).
	^ time! !

!WeakAnnouncerTest methodsFor: 'benchmarks' stamp: 'IgorStasenko 3/12/2011 20:41'!
benchWeakSubscriptionDynamic

	" run me to see how expensive becomeForward: is (compared to #benchWeakSubscriptionStatic ) "
	| object ann |
	
	object := Object new.
	ann := Announcer new.
	
	^ [
		1000 timesRepeat: [ (ann on: Announcement send: #value to: object) makeWeak ].
	] timeToRun! !

!WeakAnnouncerTest methodsFor: 'benchmarks' stamp: 'IgorStasenko 3/12/2011 20:42'!
benchWeakSubscriptionStatic

	" run me to see how cheap object creation is (compared to #benchWeakSubscriptionDynamic ) "
	| object ann |
	
	object := Object new.
	ann := Announcer new.
	
	^ [
		1000 timesRepeat: [ (ann weak on: Announcement send: #value to: object)  ].
	] timeToRun! !

!WeakAnnouncerTest methodsFor: 'private' stamp: 'IgorStasenko 3/12/2011 18:16'!
newAnnouncer
	^ Announcer new! !

!WeakAnnouncerTest methodsFor: 'testing' stamp: 'MarcusDenker 8/20/2011 13:43'!
testNoWeakBlock
	"There is no such thing as a weak block, these things never go away."

	<expectedFailure>

	| counter |
	counter := 0.

	(announcer subscribe: AnnouncementMockA do: [ :ann | counter := counter + 1 ]) makeWeak.
	
	Smalltalk garbageCollect.
	announcer announce: AnnouncementMockA.
	self assert: counter = 1.
	
	Smalltalk garbageCollect.
	announcer announce: AnnouncementMockA.
	self assert: counter = 2! !

!WeakAnnouncerTest methodsFor: 'testing' stamp: 'IgorStasenko 3/12/2011 18:23'!
testWeakObject
	| counter collector forwarder |
	counter := 0.
	collector := [ counter := counter + 1 ].
	forwarder := MessageSend receiver: collector selector: #value.
	(announcer subscribe: AnnouncementMockA send: #value to: forwarder) makeWeak.
	
	" shouldn't go away, we are still holding a reference to 'forwarder': "
	Smalltalk garbageCollect.
	announcer announce: AnnouncementMockA.
	self assert: counter = 1.
	
	" should go away as we let the only reference to 'forwarder' go: "
	forwarder := nil.
	Smalltalk garbageCollect.
	announcer announce: AnnouncementMockA.
	self assert: counter = 1! !

!WeakAnnouncerTest methodsFor: 'testing' stamp: 'IgorStasenko 3/12/2011 18:27'!
testWeakSubscription
	| obj  subscription |
	
	obj := Object new.
	
	subscription := 
		(announcer on: AnnouncementMockA send: #value to: obj) makeWeak.
		
	self assert: (obj == subscription subscriber).! !
